<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2004 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: Geotargeting.php 2024 2005-03-10 17:21:43Z andrew $
*/

/**
 * @package    Max
 * @author     Andrew Hill <andrew@awarez.net>
 */

require_once MAX_PATH . '/lib/max/language/Default.php';

/**
 * A class for determining the available geotargeting modes.
 *
 * @static
 */
class MAX_Admin_Geotargeting
{

    /**
     * A method for returning an array of the available geotargeting modes.
     *
     * @return array An array of strings representing the available geotargeting modes.
     */
    function AvailableGeotargetingModes()
    {
        Language_Default::load();
        $modes = array();
        $modes['none'] = $GLOBALS['strNone'];
        $geoDir = opendir(MAX_PATH . '/lib/max/Geotargeting/');
        while ($file = readdir($geoDir)) {
            if (is_file(MAX_PATH . '/lib/max/Geotargeting/' . $file)) {
                include_once MAX_PATH . '/lib/max/Geotargeting/' . $file;
                $module = str_replace('.php', '', $file);
                $class = 'Geotargeting_' . $module;
                if (is_callable(array($class, 'getModuleInfo'))) {
                    $modes[$module] = call_user_func(array($class, 'getModuleInfo'));
                }
            }
        }
        closedir($geoDir);
        return $modes;
    }
    
}

?>
