<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: Normal.php 2024 2005-03-10 17:21:43Z andrew $
*/

/**
 * @package    MaxMaintenance
 * @subpackage Priority
 * @author     Andrew Hill <andrew@awarez.net>
 */

require_once MAX_PATH . '/lib/max/Maintenance/Priority/AdServer/ZoneImpressionForecast/Common.php';
 
/**
 * The default implementation of {@link Maintenance_Priority_AdServer_ZoneImpressionForecast_Common}
 * distributed with Max.
 */
class Maintenance_Priority_AdServer_ZoneImpressionForecast_Normal extends Maintenance_Priority_AdServer_ZoneImpressionForecast_Common
{
    
    /**
     * The default implementation of 
     * {@link Maintenance_Priority_AdServer_ZoneImpressionForecast_Common::forecastZoneImpressions()}
     * distributed with Max.
     *
     * For each operation interval that needs to be updated, the expected impressions
     * for each zone are calculated via the following algorithm:
     *
     * - If the zone has been operational for at least two weeks (i.e. the zone has
     *   actual impressions for the past two occurrences of the same operation interval
     *   as being updated), then the expected impressions is the average of the past
     *   two operation interval's actual impressions of that zone, multiplied by a
     *   moving average trend value. The moving average trend value is the actual
     *   number of zone impressions in the previous operation interval for that zone,
     *   divided by the forecast number of zone impressions in the previous operation
     *   interval for that zone.
     * - If the zone has not been operational for at least two weeks, then the 
     *   expected impressions is set to the actual number of impressions in the
     *   previous operation interval for that zone.
     * - If the previous operation interval for that zone does not have an actual
     *   number of impressions, then the expected number of impressions for that 
     *   zone is set to 1 (one).
     *
     * @TODO Needs to be written.
     */
    function forecastZoneImpressions()
    {
        
    }
    
}

?>
