<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: Statistics.php 1531 2005-02-10 15:49:02Z andrew $
*/

/**
 * @package    Max
 * @subpackage Table
 * @author     Andrew Hill <andrew@awarez.net>
 */

require_once MAX_PATH . '/lib/max/Table.php';

/**
 * A class for creating the temporary Max database tables required
 * for performing the maintenance priority functions.
 *
 * @static
 */
class MAX_Table_Priority extends MAX_Table
{
    
    /**
     * A singleton method to create or return a single instance
     * of the {@link MAX_Table_Priority} object.
     *
     * @static
     * @param string $dbType The database type.
     * @return {@link MAX_Table_Priority} The returned {@link MAX_Table_Priority} object.
     */
    function &singleton($dbType)
    {
        $dbType = strtolower($dbType);
        static $instances;
        if (!isset($instances[$dbType])) {
            $instances[$dbType] = new MAX_Table_Priority();
            $instances[$dbType]->init(MAX_PATH . '/etc/tables_temporary_priority.' . $dbType . '.sql');
        }
        return $instances[$dbType];
    }
    
}

?>
